You can copy and paste items to and from the grid using the system clipboard.
How to copy Copy Link
Copying from the grid is enabled by default for enterprise users. To copy your selection to the system clipboard, you can use the keybind ^ Ctrl⌘ Command+C, or right click on a cell and select 'Copy' from the context menu. Unless Cell Selection or Row Selection is enabled, you will only be copying from the currently focused cell.
When copying multiple cells, the contents will be copied in an Excel compatible format, with fields separated by a \t (tab) character.
Copying Cell Ranges Copy Link
When Cell Ranges are enabled by setting gridOptions.cellSelection=true, copying will copy the Cell Range's content to your clipboard. Select a range by clicking on a cell and dragging with the mouse, then copy with the ^ Ctrl⌘ Command+C keybind.
Multiple cell ranges can be selected at once using ^ Ctrl⌘ Command and dragging with the mouse. When copying, all ranges will be copied to the clipboard. Note that the relative positions of multiple ranges is not preserved when copying, they are stacked vertically in the clipboard.
In the below example try:
- Select a cell range with click & drag
- Copy with ^ Ctrl⌘ Command+C
- Paste into an external program / text editor.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Copying Rows Copy Link
When Row Selection is enabled by setting gridOptions.rowSelection.mode to either "singleRow" or "multiRow", the default behaviour is to copy only the focused cell to the clipboard. In order to copy the whole row, enable the gridOptions.rowSelection.copySelectedRows flag.
<ag-grid-vue
:rowSelection="rowSelection"
/* other grid options ... */>
</ag-grid-vue>
this.rowSelection = {
mode: 'multiRow',
copySelectedRows: true,
};The below example demonstrates copying rows. Initially, pressing ^ Ctrl⌘ Command+C will select the focused cell, regardless of which rows have been selected. You can change this behaviour by toggling the "Copy Selected Rows" checkbox to enable the copySelectedRows flag:
- Toggle the "Copy Selected Rows" checkbox on
- Select one or more rows in the example below and press ^ Ctrl⌘ Command+C
- Paste copied content in a text editor
- When the "Copy Selected Rows" checkbox is toggled on, the pasted content includes all selected rows. When the "Copy Selected Rows" checkbox is toggled off, the pasted content includes only the focussed cell.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
RowSelectionModule,
RowSelectionOptions,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
RowSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<div class="example-header">
<label for="toggle-copy-rows">Copy Selected Rows: </label>
<input type="checkbox" id="toggle-copy-rows" v-on:change="toggleCopyRows()">
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowSelection="rowSelection"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
});
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
copySelectedRows: false,
});
const rowData = ref<IOlympicData[]>(null);
function toggleCopyRows() {
gridApi.value.setGridOption("rowSelection", {
mode: "multiRow",
copySelectedRows:
document.querySelector<HTMLInputElement>("#toggle-copy-rows")
?.checked ?? false,
});
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowSelection,
rowData,
onGridReady,
toggleCopyRows,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Copying Headers Copy Link
The column headers can be copied to the clipboard in addition to the cell contents by enabling the option copyHeadersToClipboard.
<ag-grid-vue
:copyHeadersToClipboard="copyHeadersToClipboard"
/* other grid options ... */>
</ag-grid-vue>
this.copyHeadersToClipboard = true;Set to true to also include headers when copying to clipboard using ^ Ctrl+C clipboard. Default: false |
In the below example try:
- Select a cell range with click & drag
- Copy with ^ Ctrl⌘ Command+C
- Paste into an external program / text editor, note that the column headers were also copied.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:copyHeadersToClipboard="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Custom Clipboard Interaction Copy Link
If you want to do the copy to clipboard yourself (i.e. not use the grid's clipboard interaction) then implement the callback sendToClipboard(params). Use this if you are in a non-standard web container that has a bespoke API for interacting with the clipboard. The callback gets the data to go into the clipboard, it's your job to call the bespoke API.
The example below shows using sendToClipboard(params), but rather than using the clipboard, demonstrates the callback by just printing the data to the console.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
RowSelectionModule,
RowSelectionOptions,
SendToClipboard,
SendToClipboardParams,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
RowSelectionModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="display: flex; height: 100%; flex-direction: column">
<div style="padding-bottom: 5px">
<button v-on:click="onBtCopyRows()">Copy Selected Rows to Clipboard</button>
<button v-on:click="onBtCopyRange()">Copy Selected Range to Clipboard</button>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:rowSelection="rowSelection"
:sendToClipboard="sendToClipboard"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
});
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
});
const rowData = ref<IOlympicData[]>(null);
function onBtCopyRows() {
gridApi.value!.copySelectedRowsToClipboard();
}
function onBtCopyRange() {
gridApi.value!.copySelectedRangeToClipboard();
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
function sendToClipboard(params: SendToClipboardParams) {
console.log("send to clipboard called with data:");
console.log(params.data);
}
return {
gridApi,
columnDefs,
defaultColDef,
rowSelection,
sendToClipboard,
rowData,
onGridReady,
onBtCopyRows,
onBtCopyRange,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Copying via the API Copy Link
You can use the Grid API methods: copySelectedRowsToClipboard(...) and copySelectedRangeToClipboard(...) to copy rows or ranges respectively, these API calls take optional parameters to enable copying column and group headers.
Copies the selected ranges to the clipboard. |
Copies the selected rows to the clipboard. |
How to Cut Copy Link
Cut from the grid is enabled by default for enterprise users. To cut your selection to the system clipboard, you can use the keybind ^ Ctrl⌘ Command+X, or right click on a cell and select 'Cut' from the context menu. Unless Range Selection or Row Selection is enabled, you will only be copying from the currently focused cell.
The cut operations will work exactly the same as the copy operations, with the addition that data will be removed from the grid afterwards, so the cut operations will use the same properties described above to customise the copy process.
Disabling Cut Copy Link
Since Cut is a destructive process, the suppressCutToClipboard property was added to the Grid Options.
<ag-grid-vue
:suppressCutToClipboard="suppressCutToClipboard"
/* other grid options ... */>
</ag-grid-vue>
this.suppressCutToClipboard = true;This is demonstrated in the example below. Note the following:
- Selecting a cell and pressing ^ Ctrl⌘ Command+X will not
copyorcutthe data. - The context menu will not show an option to
Cut.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:suppressCutToClipboard="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
How to Paste Copy Link
Paste is enabled by default in the enterprise version and is possible as long as the cells you're pasting into are editable (non-editable cells cannot be modified, even with a paste operation). You can paste using the keybind ^ Ctrl⌘ Command+V while focus is on the grid.
The behaviour of paste changes depending on whether you have a single cell or a range selected:
- When a single cell is selected. The paste will proceed starting at the selected cell if multiple cells are to be pasted.
- When a range of cells selected. If the selected range being pasted is larger than copied range, it will repeat if it fits evenly, otherwise it will just copy the cells into the start of the range.
Disabling Paste Copy Link
You can turn paste operations off for the entire grid, by setting the grid property suppressClipboardPaste=true.
Or you can disable pasting for a specific column or cell by setting the property suppressPaste on the column definition. This can be a boolean or a function (use a function to specify for a particular cell, or boolean for the whole column).
Pasting is on by default as long as cells are editable (non-editable cells cannot be modified, even with a paste operation).
Set to true turn paste operations off. |
Processing Pasted Data Copy Link
The clipboard data will be processed by default Using the Value Formatter for Export to format the cells when copied, and Using the Value Parser for Import to format the cells when pasted.
It is possible to override this behaviour specifically for the clipboard. This can be done either on individual cells or the whole paste operation.
Processing Individual Cells Copy Link
The interfaces and parameters for processing individual cells are as follows:
Allows you to process cells for the clipboard. Handy if for example you have Date objects that need to have a particular format if importing into Excel. |
Allows you to process header values for the clipboard. |
Allows you to process group header values for the clipboard. |
Allows you to process cells from the clipboard. Handy if for example you have number fields and want to block non-numbers from getting into the grid. |
These three callbacks above are demonstrated in the example below. Note the following:
- When cells are copied to the clipboard, values are prefixed with 'C-'. Cells can be copied by dragging a range with the mouse and hitting ^ Ctrl⌘ Command+C.
- When cells are pasted from the clipboard, values are prefixed with 'Z-'. Cells can be pasted by hitting ^ Ctrl⌘ Command+V.
- When headers are copied to the clipboard, values are prefixed with 'H-'. Headers can be copied by using the context menu.
- When group headers are copied to the clipboard, values are prefixed with 'GH-'. Headers can be copied by using the context menu.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
ProcessCellForClipboard,
ProcessCellForExportParams,
ProcessCellFromClipboard,
ProcessGroupHeaderForClipboard,
ProcessGroupHeaderForExportParams,
ProcessHeaderForClipboard,
ProcessHeaderForExportParams,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:processCellForClipboard="processCellForClipboard"
:processHeaderForClipboard="processHeaderForClipboard"
:processGroupHeaderForClipboard="processGroupHeaderForClipboard"
:processCellFromClipboard="processCellFromClipboard"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<(ColDef | ColGroupDef)[]>([
{
headerName: "Participants",
children: [
{ field: "athlete", headerName: "Athlete Name", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
],
},
{
headerName: "Olympic Games",
children: [
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver", suppressPaste: true },
{ field: "bronze" },
{ field: "total" },
],
},
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
cellDataType: false,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
function processCellForClipboard(params: ProcessCellForExportParams) {
return "C-" + params.value;
}
function processHeaderForClipboard(params: ProcessHeaderForExportParams) {
const colDef = params.column.getColDef();
let headerName = colDef.headerName || colDef.field || "";
if (colDef.headerName !== "") {
headerName = headerName.charAt(0).toUpperCase() + headerName.slice(1);
}
return "H-" + headerName;
}
function processGroupHeaderForClipboard(
params: ProcessGroupHeaderForExportParams,
) {
const colGroupDef = params.columnGroup.getColGroupDef() || ({} as any);
const headerName = colGroupDef.headerName || "";
if (headerName === "") {
return "";
}
return "GH-" + headerName;
}
function processCellFromClipboard(params: ProcessCellForExportParams) {
return "Z-" + params.value;
}
return {
gridApi,
columnDefs,
defaultColDef,
processCellForClipboard,
processHeaderForClipboard,
processGroupHeaderForClipboard,
processCellFromClipboard,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Processing Data from Clipboard Copy Link
To have complete control of processing clipboard data when pasting, you can use the callback below:
Allows complete control of the paste operation, including cancelling the operation (so nothing happens) or replacing the data with other data. |
The following example shows custom code to process the data from the clipboard:
- The cells are coloured based on the colour that the cell content starts with
- Copy a cell range in the grid which includes a cell value that starts with
Red. Pasting into the grid will paste a custom 4x4 cell grid. - Copy a cell range in the grid which includes a cell value that starts with
Yellowand doesn’t include anyRedcell values. Pasting this copied cell range will cancel the paste action and not paste anything - Any other copied cell data will be pasted as-is
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
CellSelectionOptions,
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
ProcessDataFromClipboard,
ProcessDataFromClipboardParams,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
CellStyleModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:rowData="rowData"
:cellSelection="true"
:defaultColDef="defaultColDef"
:processDataFromClipboard="processDataFromClipboard"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "a" },
{ field: "b" },
{ field: "c" },
{ field: "d" },
{ field: "e" },
]);
const rowData = ref<any[] | null>(getData());
const defaultColDef = ref<ColDef>({
editable: true,
minWidth: 120,
flex: 1,
cellClassRules: {
"cell-green": 'value && value.startsWith("Green")',
"cell-blue": 'value && value.startsWith("Blue")',
"cell-red": 'value && value.startsWith("Red")',
"cell-yellow": 'value && value.startsWith("Yellow")',
},
});
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
const processDataFromClipboard: (
params: ProcessDataFromClipboardParams,
) => string[][] | null = (params: ProcessDataFromClipboardParams) => {
let containsRed;
let containsYellow;
const data = params.data;
for (let i = 0; i < data.length; i++) {
const row = data[i];
for (let j = 0; j < row.length; j++) {
const value = row[j];
if (value) {
if (value.startsWith("Red")) {
containsRed = true;
} else if (value.startsWith("Yellow")) {
containsYellow = true;
}
}
}
}
if (containsRed) {
// replace the paste request with another
return [
["Custom 1", "Custom 2"],
["Custom 3", "Custom 4"],
];
}
if (containsYellow) {
// cancels the paste
return null;
}
return data;
};
return {
gridApi,
columnDefs,
rowData,
defaultColDef,
processDataFromClipboard,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Pasting New Rows at the Bottom of the Grid Copy Link
By default, when pasting multiple rows near the last record shown in the grid, any rows exceeding the total number of rows shown in the grid will not be pasted.
In order to insert all the copied rows in the grid, a custom processDataFromClipboard function is needed to add the necessary number of new rows using the Transaction Update API.
The example below uses a custom processDataFromClipboard function to add new rows to the grid, to fit all the copied rows:
- Select the top 3 rows in the grid using ⇧ Shift + click
- Press ^ Ctrl⌘ Command+C to copy the selected rows
- Select the
Ryan Lochtecell on the last row and press ^ Ctrl⌘ Command+V to paste the copied rows - Notice that the
Ryan Lochterow has been overwritten and 2 extra rows are created at the bottom of the grid to accommodate the additional 2 rows pasted
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelApiModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnApiModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
ProcessDataFromClipboard,
ProcessDataFromClipboardParams,
RowApiModule,
RowSelectionModule,
RowSelectionOptions,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnApiModule,
RowApiModule,
ClientSideRowModelApiModule,
NumberEditorModule,
TextEditorModule,
RowSelectionModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowSelection="rowSelection"
:processDataFromClipboard="processDataFromClipboard"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ headerName: "Athlete", field: "athlete", width: 150 },
{ headerName: "Age", field: "age", width: 90 },
{ headerName: "Country", field: "country", width: 120 },
{ headerName: "Year", field: "year", width: 90 },
{ headerName: "Date", field: "date", width: 110 },
{ headerName: "Sport", field: "sport", width: 110 },
]);
const defaultColDef = ref<ColDef>({
editable: true,
});
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
checkboxes: false,
headerCheckbox: false,
enableClickSelection: true,
copySelectedRows: true,
});
const rowData = ref<any[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data.slice(0, 8));
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
const processDataFromClipboard: (
params: ProcessDataFromClipboardParams,
) => string[][] | null = (params: ProcessDataFromClipboardParams) => {
const data = [...params.data];
const emptyLastRow =
data[data.length - 1][0] === "" && data[data.length - 1].length === 1;
if (emptyLastRow) {
data.splice(data.length - 1, 1);
}
const lastIndex = params.api!.getDisplayedRowCount() - 1;
const focusedCell = params.api!.getFocusedCell();
const focusedIndex = focusedCell!.rowIndex;
if (focusedIndex + data.length - 1 > lastIndex) {
const resultLastIndex = focusedIndex + (data.length - 1);
const numRowsToAdd = resultLastIndex - lastIndex;
const rowsToAdd: any[] = [];
for (let i = 0; i < numRowsToAdd; i++) {
const index = data.length - 1;
const row = data.slice(index, index + 1)[0];
// Create row object
const rowObject: any = {};
let currentColumn: any = focusedCell!.column;
row.forEach((item) => {
if (!currentColumn) {
return;
}
rowObject[currentColumn.colDef.field] = item;
currentColumn = params.api!.getDisplayedColAfter(currentColumn);
});
rowsToAdd.push(rowObject);
}
params.api!.applyTransaction({ add: rowsToAdd });
}
return data;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowSelection,
processDataFromClipboard,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Read Only Edit Copy Link
When the grid is in Read Only Edit mode the Clipboard will not update the data inside the grid. Instead the grid fires cellEditRequest events allowing the application to process the update request.
Value has changed after editing. Only fires when readOnlyEdit=true. |
The example below will show how to update cell value combining the Clipboard with readOnlyEdit=true.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellEditRequestEvent,
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, ClipboardModule } from "ag-grid-enterprise";
import { IOlympicDataWithId } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
CellSelectionModule,
]);
let rowImmutableStore: any[];
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:getRowId="getRowId"
:cellSelection="true"
:readOnlyEdit="true"
:rowData="rowData"
@cell-edit-request="onCellEditRequest"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicDataWithId> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
editable: true,
});
const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) =>
String(params.data.id),
);
const rowData = ref<IOlympicDataWithId[]>(null);
function onCellEditRequest(event: CellEditRequestEvent) {
const data = event.data;
const field = event.colDef.field;
const newValue = event.newValue;
const oldItem = rowImmutableStore.find((row) => row.id === data.id);
if (!oldItem || !field) {
return;
}
const newItem = { ...oldItem };
newItem[field] = newValue;
console.log("onCellEditRequest, updating " + field + " to " + newValue);
rowImmutableStore = rowImmutableStore.map((oldItem) =>
oldItem.id == newItem.id ? newItem : oldItem,
);
gridApi.value!.setGridOption("rowData", rowImmutableStore);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
data.forEach((item, index) => (item.id = index));
rowImmutableStore = data;
params.api!.setGridOption("rowData", rowImmutableStore);
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
getRowId,
rowData,
onGridReady,
onCellEditRequest,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Changing the Delimiter for Copy & Paste Copy Link
By default, the grid will use \t (tab) as the field delimiter. This is to keep the copy / paste compatible with Excel. If you want another delimiter then you can set the property gridOptions.clipboardDelimiter to a value of your choosing.
Using the Browser's Text Selection Copy Link
The grid's selection and copy features replace the built-in browser behaviour for selecting and copying text. If you want to use the normal browser behaviour instead, you should set enableCellTextSelection=true in the gridOptions. Note the following:
When
enableCellTextSelection=true, pressing ^ Ctrl⌘ Command+C doesn’t copy the focused cell value, but only the selected text inside the grid cell. When using AG Grid Enterprise, the user can copy the entire cell value by right-clicking the grid cell to show the context menu and clicking the any of the Copy menu items.When
enableCellTextSelection=true, the optionensureDomOrder=trueneeds to be set for correct accessibility support. See Ensure DOM Element order.
This is not an enterprise config and can be used at any time to enable cell text selection.
See this behaviour shown in the example below:
Focus a grid cell and press ^ Ctrl⌘ Command+C. The cell value will not be copied because no text is selected.
Click a cell and drag across its value to select the text. Press ^ Ctrl⌘ Command+C and the value will be copied.
This sample is using AG Grid Community version, so the context menu is not available to copy the focused cell value. In AG Grid Enterprise the context menu will be available to copy the entire focused cell value without having to select it as text.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:ensureDomOrder="true"
:enableCellTextSelection="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver", suppressPaste: true },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Clipboard Events Copy Link
The following events are relevant to clipboard operations:
Cut operation has started. |
Cut operation has ended. |
Paste operation has started. |
Paste operation has ended. |
Cell value has changed. This occurs after the following scenarios: readOnlyEdit = true;
editing was cancelled (e.g. Escape key was pressed);
or new value is of the wrong cell data type for the column. |
For a cut or paste operation the events will be fired as:
- One
cutStart/pasteStartevent. - Many
cellValueChangedevents. - One
cutEnd/pasteEndevent.
If the application is doing work each time it receives a cellValueChanged, you can use the cutStart/pasteStart and cutEnd/pasteEnd events to suspend the applications work and then do the work for all cells impacted by the cut/paste operation after the cut/paste operation.
There are no events triggered by copy to clipboard as this does not change the grid's data.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
CellValueChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CutEndEvent,
CutStartEvent,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
PasteEndEvent,
PasteStartEvent,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:rowData="rowData"
@cell-value-changed="onCellValueChanged"
@cut-start="onCutStart"
@cut-end="onCutEnd"
@paste-start="onPasteStart"
@paste-end="onPasteEnd"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
});
const rowData = ref<IOlympicData[]>(null);
function onCellValueChanged(params: CellValueChangedEvent) {
console.log("Callback onCellValueChanged:", params);
}
function onCutStart(params: CutStartEvent) {
console.log("Callback onCutStart:", params);
}
function onCutEnd(params: CutEndEvent) {
console.log("Callback onCutEnd:", params);
}
function onPasteStart(params: PasteStartEvent) {
console.log("Callback onPasteStart:", params);
}
function onPasteEnd(params: PasteEndEvent) {
console.log("Callback onPasteEnd:", params);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
onCellValueChanged,
onCutStart,
onCutEnd,
onPasteStart,
onPasteEnd,
};
},
});
const app = createApp(VueExample);
app.mount("#app");

You can copy and paste items to and from the grid using the system clipboard.
How to copy Copy Link
Copying from the grid is enabled by default for enterprise users. To copy your selection to the system clipboard, you can use the keybind ^ Ctrlâ Command+C, or right click on a cell and select 'Copy' from the context menu. Unless Cell Selection or Row Selection is enabled, you will only be copying from the currently focused cell.
When copying multiple cells, the contents will be copied in an Excel compatible format, with fields separated by a \t (tab) character.
Copying Cell Ranges Copy Link
When Cell Ranges are enabled by setting gridOptions.cellSelection=true, copying will copy the Cell Range's content to your clipboard. Select a range by clicking on a cell and dragging with the mouse, then copy with the ^ Ctrlâ Command+C keybind.
Multiple cell ranges can be selected at once using ^ Ctrlâ Command and dragging with the mouse. When copying, all ranges will be copied to the clipboard. Note that the relative positions of multiple ranges is not preserved when copying, they are stacked vertically in the clipboard.
In the below example try:
- Select a cell range with click & drag
- Copy with ^ Ctrlâ Command+C
- Paste into an external program / text editor.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Copying Rows Copy Link
When Row Selection is enabled by setting gridOptions.rowSelection.mode to either "singleRow" or "multiRow", the default behaviour is to copy only the focused cell to the clipboard. In order to copy the whole row, enable the gridOptions.rowSelection.copySelectedRows flag.
<ag-grid-angular
[rowSelection]="rowSelection"
/* other grid options ... */ />
this.rowSelection = {
mode: 'multiRow',
copySelectedRows: true,
};The below example demonstrates copying rows. Initially, pressing ^ Ctrlâ Command+C will select the focused cell, regardless of which rows have been selected. You can change this behaviour by toggling the "Copy Selected Rows" checkbox to enable the copySelectedRows flag:
- Toggle the "Copy Selected Rows" checkbox on
- Select one or more rows in the example below and press ^ Ctrlâ Command+C
- Paste copied content in a text editor
- When the "Copy Selected Rows" checkbox is toggled on, the pasted content includes all selected rows. When the "Copy Selected Rows" checkbox is toggled off, the pasted content includes only the focussed cell.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
RowSelectionModule,
RowSelectionOptions,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
RowSelectionModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="example-wrapper">
<div class="example-header">
<label for="toggle-copy-rows">Copy Selected Rows: </label>
<input
type="checkbox"
id="toggle-copy-rows"
(change)="toggleCopyRows()"
/>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowSelection]="rowSelection"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
};
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
copySelectedRows: false,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
toggleCopyRows() {
this.gridApi.setGridOption("rowSelection", {
mode: "multiRow",
copySelectedRows:
document.querySelector<HTMLInputElement>("#toggle-copy-rows")
?.checked ?? false,
});
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
.example-header {
margin-bottom: 10px;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Copying Headers Copy Link
The column headers can be copied to the clipboard in addition to the cell contents by enabling the option copyHeadersToClipboard.
<ag-grid-angular
[copyHeadersToClipboard]="copyHeadersToClipboard"
/* other grid options ... */ />
this.copyHeadersToClipboard = true;Set to true to also include headers when copying to clipboard using ^ Ctrl+C clipboard. Default: false |
In the below example try:
- Select a cell range with click & drag
- Copy with ^ Ctrlâ Command+C
- Paste into an external program / text editor, note that the column headers were also copied.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[copyHeadersToClipboard]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Custom Clipboard Interaction Copy Link
If you want to do the copy to clipboard yourself (i.e. not use the grid's clipboard interaction) then implement the callback sendToClipboard(params). Use this if you are in a non-standard web container that has a bespoke API for interacting with the clipboard. The callback gets the data to go into the clipboard, it's your job to call the bespoke API.
The example below shows using sendToClipboard(params), but rather than using the clipboard, demonstrates the callback by just printing the data to the console.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
RowSelectionModule,
RowSelectionOptions,
SendToClipboard,
SendToClipboardParams,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
RowSelectionModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div style="display: flex; height: 100%; flex-direction: column">
<div style="padding-bottom: 5px">
<button (click)="onBtCopyRows()">Copy Selected Rows to Clipboard</button>
<button (click)="onBtCopyRange()">
Copy Selected Range to Clipboard
</button>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[rowSelection]="rowSelection"
[sendToClipboard]="sendToClipboard"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
};
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onBtCopyRows() {
this.gridApi.copySelectedRowsToClipboard();
}
onBtCopyRange() {
this.gridApi.copySelectedRangeToClipboard();
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
sendToClipboard = (params: SendToClipboardParams) => {
console.log("send to clipboard called with data:");
console.log(params.data);
};
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Copying via the API Copy Link
You can use the Grid API methods: copySelectedRowsToClipboard(...) and copySelectedRangeToClipboard(...) to copy rows or ranges respectively, these API calls take optional parameters to enable copying column and group headers.
Copies the selected ranges to the clipboard. |
Copies the selected rows to the clipboard. |
How to Cut Copy Link
Cut from the grid is enabled by default for enterprise users. To cut your selection to the system clipboard, you can use the keybind ^ Ctrlâ Command+X, or right click on a cell and select 'Cut' from the context menu. Unless Range Selection or Row Selection is enabled, you will only be copying from the currently focused cell.
The cut operations will work exactly the same as the copy operations, with the addition that data will be removed from the grid afterwards, so the cut operations will use the same properties described above to customise the copy process.
Disabling Cut Copy Link
Since Cut is a destructive process, the suppressCutToClipboard property was added to the Grid Options.
<ag-grid-angular
[suppressCutToClipboard]="suppressCutToClipboard"
/* other grid options ... */ />
this.suppressCutToClipboard = true;This is demonstrated in the example below. Note the following:
- Selecting a cell and pressing ^ Ctrlâ Command+X will not
copyorcutthe data. - The context menu will not show an option to
Cut.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[suppressCutToClipboard]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} How to Paste Copy Link
Paste is enabled by default in the enterprise version and is possible as long as the cells you're pasting into are editable (non-editable cells cannot be modified, even with a paste operation). You can paste using the keybind ^ Ctrlâ Command+V while focus is on the grid.
The behaviour of paste changes depending on whether you have a single cell or a range selected:
- When a single cell is selected. The paste will proceed starting at the selected cell if multiple cells are to be pasted.
- When a range of cells selected. If the selected range being pasted is larger than copied range, it will repeat if it fits evenly, otherwise it will just copy the cells into the start of the range.
Disabling Paste Copy Link
You can turn paste operations off for the entire grid, by setting the grid property suppressClipboardPaste=true.
Or you can disable pasting for a specific column or cell by setting the property suppressPaste on the column definition. This can be a boolean or a function (use a function to specify for a particular cell, or boolean for the whole column).
Pasting is on by default as long as cells are editable (non-editable cells cannot be modified, even with a paste operation).
Set to true turn paste operations off. |
Processing Pasted Data Copy Link
The clipboard data will be processed by default Using the Value Formatter for Export to format the cells when copied, and Using the Value Parser for Import to format the cells when pasted.
It is possible to override this behaviour specifically for the clipboard. This can be done either on individual cells or the whole paste operation.
Processing Individual Cells Copy Link
The interfaces and parameters for processing individual cells are as follows:
Allows you to process cells for the clipboard. Handy if for example you have Date objects that need to have a particular format if importing into Excel. |
Allows you to process header values for the clipboard. |
Allows you to process group header values for the clipboard. |
Allows you to process cells from the clipboard. Handy if for example you have number fields and want to block non-numbers from getting into the grid. |
These three callbacks above are demonstrated in the example below. Note the following:
- When cells are copied to the clipboard, values are prefixed with 'C-'. Cells can be copied by dragging a range with the mouse and hitting ^ Ctrlâ Command+C.
- When cells are pasted from the clipboard, values are prefixed with 'Z-'. Cells can be pasted by hitting ^ Ctrlâ Command+V.
- When headers are copied to the clipboard, values are prefixed with 'H-'. Headers can be copied by using the context menu.
- When group headers are copied to the clipboard, values are prefixed with 'GH-'. Headers can be copied by using the context menu.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
ProcessCellForClipboard,
ProcessCellForExportParams,
ProcessCellFromClipboard,
ProcessGroupHeaderForClipboard,
ProcessGroupHeaderForExportParams,
ProcessHeaderForClipboard,
ProcessHeaderForExportParams,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[processCellForClipboard]="processCellForClipboard"
[processHeaderForClipboard]="processHeaderForClipboard"
[processGroupHeaderForClipboard]="processGroupHeaderForClipboard"
[processCellFromClipboard]="processCellFromClipboard"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: (ColDef | ColGroupDef)[] = [
{
headerName: "Participants",
children: [
{ field: "athlete", headerName: "Athlete Name", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
],
},
{
headerName: "Olympic Games",
children: [
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver", suppressPaste: true },
{ field: "bronze" },
{ field: "total" },
],
},
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
cellDataType: false,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
processCellForClipboard = (params: ProcessCellForExportParams) => {
return "C-" + params.value;
};
processHeaderForClipboard = (params: ProcessHeaderForExportParams) => {
const colDef = params.column.getColDef();
let headerName = colDef.headerName || colDef.field || "";
if (colDef.headerName !== "") {
headerName = headerName.charAt(0).toUpperCase() + headerName.slice(1);
}
return "H-" + headerName;
};
processGroupHeaderForClipboard = (
params: ProcessGroupHeaderForExportParams,
) => {
const colGroupDef = params.columnGroup.getColGroupDef() || ({} as any);
const headerName = colGroupDef.headerName || "";
if (headerName === "") {
return "";
}
return "GH-" + headerName;
};
processCellFromClipboard = (params: ProcessCellForExportParams) => {
return "Z-" + params.value;
};
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Processing Data from Clipboard Copy Link
To have complete control of processing clipboard data when pasting, you can use the callback below:
Allows complete control of the paste operation, including cancelling the operation (so nothing happens) or replacing the data with other data. |
The following example shows custom code to process the data from the clipboard:
- The cells are coloured based on the colour that the cell content starts with
- Copy a cell range in the grid which includes a cell value that starts with
Red. Pasting into the grid will paste a custom 4x4 cell grid. - Copy a cell range in the grid which includes a cell value that starts with
Yellowand doesnât include anyRedcell values. Pasting this copied cell range will cancel the paste action and not paste anything - Any other copied cell data will be pasted as-is
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
CellSelectionOptions,
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
ProcessDataFromClipboard,
ProcessDataFromClipboardParams,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
CellStyleModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[rowData]="rowData"
[cellSelection]="true"
[defaultColDef]="defaultColDef"
[processDataFromClipboard]="processDataFromClipboard"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "a" },
{ field: "b" },
{ field: "c" },
{ field: "d" },
{ field: "e" },
];
rowData: any[] | null = getData();
defaultColDef: ColDef = {
editable: true,
minWidth: 120,
flex: 1,
cellClassRules: {
"cell-green": 'value && value.startsWith("Green")',
"cell-blue": 'value && value.startsWith("Blue")',
"cell-red": 'value && value.startsWith("Red")',
"cell-yellow": 'value && value.startsWith("Yellow")',
},
};
processDataFromClipboard = (
params: ProcessDataFromClipboardParams,
): string[][] | null => {
let containsRed;
let containsYellow;
const data = params.data;
for (let i = 0; i < data.length; i++) {
const row = data[i];
for (let j = 0; j < row.length; j++) {
const value = row[j];
if (value) {
if (value.startsWith("Red")) {
containsRed = true;
} else if (value.startsWith("Yellow")) {
containsYellow = true;
}
}
}
}
if (containsRed) {
// replace the paste request with another
return [
["Custom 1", "Custom 2"],
["Custom 3", "Custom 4"],
];
}
if (containsYellow) {
// cancels the paste
return null;
}
return data;
};
}
.cell-red {
background-color: #cc222244;
}
.cell-green {
background-color: #33cc3344;
}
.cell-blue {
background-color: #2244cc44;
}
.cell-yellow {
background-color: #ccaa22a9;
}
export function getData(): any[] {
const data = [];
for (let i = 0; i < 20; i++) {
data.push({
a: 'Green ' + i * 2,
b: 'Green ' + i * 3 + 11,
c: 'Blue ' + i * 3 + 155,
d: 'Red ' + i * 4 + 265,
e: 'Yellow ' + i + 23,
});
}
return data;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Pasting New Rows at the Bottom of the Grid Copy Link
By default, when pasting multiple rows near the last record shown in the grid, any rows exceeding the total number of rows shown in the grid will not be pasted.
In order to insert all the copied rows in the grid, a custom processDataFromClipboard function is needed to add the necessary number of new rows using the Transaction Update API.
The example below uses a custom processDataFromClipboard function to add new rows to the grid, to fit all the copied rows:
- Select the top 3 rows in the grid using â§ Shift + click
- Press ^ Ctrlâ Command+C to copy the selected rows
- Select the
Ryan Lochtecell on the last row and press ^ Ctrlâ Command+V to paste the copied rows - Notice that the
Ryan Lochterow has been overwritten and 2 extra rows are created at the bottom of the grid to accommodate the additional 2 rows pasted
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelApiModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnApiModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
ProcessDataFromClipboard,
ProcessDataFromClipboardParams,
RowApiModule,
RowSelectionModule,
RowSelectionOptions,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnApiModule,
RowApiModule,
ClientSideRowModelApiModule,
NumberEditorModule,
TextEditorModule,
RowSelectionModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowSelection]="rowSelection"
[processDataFromClipboard]="processDataFromClipboard"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ headerName: "Athlete", field: "athlete", width: 150 },
{ headerName: "Age", field: "age", width: 90 },
{ headerName: "Country", field: "country", width: 120 },
{ headerName: "Year", field: "year", width: 90 },
{ headerName: "Date", field: "date", width: 110 },
{ headerName: "Sport", field: "sport", width: 110 },
];
defaultColDef: ColDef = {
editable: true,
};
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
checkboxes: false,
headerCheckbox: false,
enableClickSelection: true,
copySelectedRows: true,
};
rowData!: any[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent) {
this.http
.get<any[]>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data.slice(0, 8)));
}
processDataFromClipboard = (
params: ProcessDataFromClipboardParams,
): string[][] | null => {
const data = [...params.data];
const emptyLastRow =
data[data.length - 1][0] === "" && data[data.length - 1].length === 1;
if (emptyLastRow) {
data.splice(data.length - 1, 1);
}
const lastIndex = params.api!.getDisplayedRowCount() - 1;
const focusedCell = params.api!.getFocusedCell();
const focusedIndex = focusedCell!.rowIndex;
if (focusedIndex + data.length - 1 > lastIndex) {
const resultLastIndex = focusedIndex + (data.length - 1);
const numRowsToAdd = resultLastIndex - lastIndex;
const rowsToAdd: any[] = [];
for (let i = 0; i < numRowsToAdd; i++) {
const index = data.length - 1;
const row = data.slice(index, index + 1)[0];
// Create row object
const rowObject: any = {};
let currentColumn: any = focusedCell!.column;
row.forEach((item) => {
if (!currentColumn) {
return;
}
rowObject[currentColumn.colDef.field] = item;
currentColumn = params.api!.getDisplayedColAfter(currentColumn);
});
rowsToAdd.push(rowObject);
}
params.api!.applyTransaction({ add: rowsToAdd });
}
return data;
};
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Read Only Edit Copy Link
When the grid is in Read Only Edit mode the Clipboard will not update the data inside the grid. Instead the grid fires cellEditRequest events allowing the application to process the update request.
Value has changed after editing. Only fires when readOnlyEdit=true. |
The example below will show how to update cell value combining the Clipboard with readOnlyEdit=true.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellEditRequestEvent,
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, ClipboardModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
CellSelectionModule,
]);
import { IOlympicDataWithId } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[getRowId]="getRowId"
[cellSelection]="true"
[readOnlyEdit]="true"
[rowData]="rowData"
(cellEditRequest)="onCellEditRequest($event)"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicDataWithId>;
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
editable: true,
};
getRowId: GetRowIdFunc = (params: GetRowIdParams) => String(params.data.id);
rowData!: IOlympicDataWithId[];
constructor(private http: HttpClient) {}
onCellEditRequest(event: CellEditRequestEvent) {
const data = event.data;
const field = event.colDef.field;
const newValue = event.newValue;
const oldItem = rowImmutableStore.find((row) => row.id === data.id);
if (!oldItem || !field) {
return;
}
const newItem = { ...oldItem };
newItem[field] = newValue;
console.log("onCellEditRequest, updating " + field + " to " + newValue);
rowImmutableStore = rowImmutableStore.map((oldItem) =>
oldItem.id == newItem.id ? newItem : oldItem,
);
this.gridApi.setGridOption("rowData", rowImmutableStore);
}
onGridReady(params: GridReadyEvent<IOlympicDataWithId>) {
this.gridApi = params.api;
this.http
.get<
IOlympicDataWithId[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
data.forEach((item, index) => (item.id = index));
rowImmutableStore = data;
params.api!.setGridOption("rowData", rowImmutableStore);
});
}
}
let rowImmutableStore: any[];
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicDataWithId extends IOlympicData {
id: number;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Changing the Delimiter for Copy & Paste Copy Link
By default, the grid will use \t (tab) as the field delimiter. This is to keep the copy / paste compatible with Excel. If you want another delimiter then you can set the property gridOptions.clipboardDelimiter to a value of your choosing.
Using the Browser's Text Selection Copy Link
The grid's selection and copy features replace the built-in browser behaviour for selecting and copying text. If you want to use the normal browser behaviour instead, you should set enableCellTextSelection=true in the gridOptions. Note the following:
When
enableCellTextSelection=true, pressing ^ Ctrlâ Command+C doesnât copy the focused cell value, but only the selected text inside the grid cell. When using AG Grid Enterprise, the user can copy the entire cell value by right-clicking the grid cell to show the context menu and clicking the any of the Copy menu items.When
enableCellTextSelection=true, the optionensureDomOrder=trueneeds to be set for correct accessibility support. See Ensure DOM Element order.
This is not an enterprise config and can be used at any time to enable cell text selection.
See this behaviour shown in the example below:
Focus a grid cell and press ^ Ctrlâ Command+C. The cell value will not be copied because no text is selected.
Click a cell and drag across its value to select the text. Press ^ Ctrlâ Command+C and the value will be copied.
This sample is using AG Grid Community version, so the context menu is not available to copy the focused cell value. In AG Grid Enterprise the context menu will be available to copy the entire focused cell value without having to select it as text.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[ensureDomOrder]="true"
[enableCellTextSelection]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver", suppressPaste: true },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Clipboard Events Copy Link
The following events are relevant to clipboard operations:
Cut operation has started. |
Cut operation has ended. |
Paste operation has started. |
Paste operation has ended. |
Cell value has changed. This occurs after the following scenarios: readOnlyEdit = true;
editing was cancelled (e.g. Escape key was pressed);
or new value is of the wrong cell data type for the column. |
For a cut or paste operation the events will be fired as:
- One
cutStart/pasteStartevent. - Many
cellValueChangedevents. - One
cutEnd/pasteEndevent.
If the application is doing work each time it receives a cellValueChanged, you can use the cutStart/pasteStart and cutEnd/pasteEnd events to suspend the applications work and then do the work for all cells impacted by the cut/paste operation after the cut/paste operation.
There are no events triggered by copy to clipboard as this does not change the grid's data.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
CellValueChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CutEndEvent,
CutStartEvent,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
PasteEndEvent,
PasteStartEvent,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[rowData]="rowData"
(cellValueChanged)="onCellValueChanged($event)"
(cutStart)="onCutStart($event)"
(cutEnd)="onCutEnd($event)"
(pasteStart)="onPasteStart($event)"
(pasteEnd)="onPasteEnd($event)"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onCellValueChanged(params: CellValueChangedEvent) {
console.log("Callback onCellValueChanged:", params);
}
onCutStart(params: CutStartEvent) {
console.log("Callback onCutStart:", params);
}
onCutEnd(params: CutEndEvent) {
console.log("Callback onCutEnd:", params);
}
onPasteStart(params: PasteStartEvent) {
console.log("Callback onPasteStart:", params);
}
onPasteEnd(params: PasteEndEvent) {
console.log("Callback onPasteEnd:", params);
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}